<template>
  <el-main>
    <el-form ref="form" :model="form" :disabled="form.registerState =='1'">
      <el-form-item label="文书名称及文号" :label-width="formLabelWidth">
        <el-input v-model="form.nameAndNumber" autocomplete="off"></el-input>
      </el-form-item>

      <el-row>
        <el-col :span="12">
          <el-form-item label="受送达人 " :label-width="formLabelWidth">
            <el-input
              v-model="form.summonedPerson"
              autocomplete="off"
            ></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="送达日期" :label-width="formLabelWidth">
            <el-date-picker
              v-model="form.deliveryDate"
              type="date"
              :value-format="`yyyy-MM-dd`"
              placeholder="选择日期"
              style="width: 100%"
            >
            </el-date-picker>
          </el-form-item>
        </el-col>
      </el-row>

      <el-form-item label="送达地点" :label-width="formLabelWidth">
        <el-input
          v-model="form.deliveryAddress"
          autocomplete="off"
        ></el-input>
      </el-form-item>
      <el-form-item label="送达方式" :label-width="formLabelWidth">
        <el-select v-model="form.deliveryWay" placeholder="请选择" style="width: 100%">
          <el-option
            v-for="item in deliveryWays"
            :key="item.value"
            :label="item.label"
            :value="item.value"
          >
          </el-option>
        </el-select>
      </el-form-item>

      <el-row>
        <el-col :span="12">
          <el-form-item label="收件人" :label-width="formLabelWidth">
            <el-input
              v-model="form.recipientImg"
              autocomplete="off"
            ></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="收件日期" :label-width="formLabelWidth">
            <el-date-picker
              v-model="form.receiptTime"
              type="date"
              :value-format="`yyyy-MM-dd`"
              placeholder="选择日期"
              style="width: 100%"
            >
            </el-date-picker>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row>
        <el-col :span="12">
          <el-form-item label="与受送达人关系 " :label-width="formLabelWidth">
            <el-input v-model="form.relation" autocomplete="off"></el-input>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="送达人签名 " :label-width="formLabelWidth">
            <el-input
              v-model="form.deliveryImg"
              autocomplete="off"
            ></el-input>
          </el-form-item>
        </el-col>
      </el-row>

      <el-row>
        <el-col :span="12">
          <el-form-item label="送达人签名日期 " :label-width="formLabelWidth">
            <el-date-picker
              v-model="form.deliveryTime"
              type="date"
              :value-format="`yyyy-MM-dd`"
              placeholder="选择日期"
              style="width: 100%"
            >
            </el-date-picker>
          </el-form-item>
        </el-col>
        <el-col :span="12">
          <el-form-item label="是否拒收 " :label-width="formLabelWidth">
            <el-select v-model="form.isReject" placeholder="请选择" style="width: 100%">
              <el-option
                v-for="item in deliveryWaies"
                :key="item.value"
                :label="item.label"
                :value="item.value"
              >
              </el-option>
            </el-select>
          </el-form-item>
        </el-col>
      </el-row>

<!--      <el-form-item label="备注 " :label-width="formLabelWidth">-->
<!--        <el-input v-model="form.remark" autocomplete="off"></el-input>-->
<!--      </el-form-item>-->
      <WordView ref="wordInfo" :isShowYulan="showView" @cancel="cancelWord"></WordView>
    </el-form>
    <div style="text-align: center">
      <el-button v-if="form.registerState!='1'" plain @click="dataFormSubmit('0')">保存</el-button>
      <el-button v-if="form.registerState!='1'" type="warning" plain @click="dataFormSubmit('1')">定稿</el-button>
      <el-button type="primary" plain @click="viewVord(form)">预览</el-button>
      <el-button type="success" plain @click="downloadWord(form)">下载</el-button>
    </div>
  </el-main>
</template>

<script>

import WordView from "@/views/News/word-view";
import {getObj, saveObj} from "@/api/News/certificateOfService";
import moment from "moment";
import {remote} from "@/api/admin/dict"
import {getfindAll} from "@/api/News/useres";

export default {
  name: "certificateOfService",
  props:['isShowYulan','id','isFinish','processId','title'],
  components:{
    WordView
  },
  data() {
    return {
      showView: false,
      formLook:{
        registerId:this.id,
        tableName:this.title,
      },
      form: {
        unitName: "",
        litigant: "",
        place: "",
        caseName: "",
        hearingTime: "",
        host: "",
        hearingOfficer: "",
        recorder: "",
        phoneName: "",
        phone: "",
        notificationTime: "",
        receiptTime: "",
        litigantPhone: "",
        relation:"",
        isReject:"",
        registerState: ""
      },
      deliveryWays:[],
      deliveryWaies:[],
      formLabelWidth: "140px",
    };
  },
  created() {
    this.init()
  },
  methods: {
    init() {
      //查询字典
      remote('delivery_method').then(res => {
        this.deliveryWays = res.data.data;
      })
      //查询人员
      remote('whether').then(res => {
        this.deliveryWaies = res.data.data;
      })
      getObj(this.formLook).then((res) => {
        if (res.data.code == 0) {
          // 转换null为""
          let v = res.data.data;
          for (let attr in v) {
            if (v[attr] == null) {
              v[attr] = "";
            }
          }
          let str = JSON.stringify(v);
          let data = JSON.parse(str);
          this.form = data;
        }
      });
    },
    /*reset(){
      this.form = {
        unitName: "",
        litigant: "",
        place: "",
        caseName: "",
        hearingTime: "",
        host: "",
        hearingOfficer: "",
        recorder: "",
        phoneName: "",
        phone: "",
        notificationTime: "",
        receiptTime: "",
        litigantPhone: "",
        relation:"",
        isReject:"",
      }
    },*/
    dataFormSubmit(type) {
      this.$refs['form'].validate((valid) => {
        if (valid) {
          let obj = this;
          if ("1" == type) {
            this.$confirm('保存为定稿将不能修改，是否继续？', '提示', {
              confirmButtonText: '是',
              cancelButtonText: '否',
              type: 'warning'
            }).then(function () {
              obj.form.registerState = type;
              obj.form.registerId = obj.id;
              obj.form.processId = obj.processId;
              saveObj(obj.form).then((res) => {
                // this.submitLoading = false;
                obj.$message.success('操作成功');
                obj.cancel();
              })
            })
          } else {
            obj.form.registerState = type;
            obj.form.registerId = obj.id;
            obj.form.processId = obj.processId;
            saveObj(obj.form).then((res) => {
              // this.submitLoading = false;
              obj.$message.success("操作成功");
              obj.cancel();
            })
          }
        }
      })
    },
    cancel() {
      // this.reset();
      this.$emit('cancel', false);
    },
    cancelWord() {
      this.showView = false;
    },
    viewVord(data) {
      if(data.registerState == null || data.registerState == ""){
        //预览前先进行保存
        data.registerState = '0';
        data.registerId = this.id;
        data.processId = this.processId;
        saveObj(data).then((res) => {
        })
      }
      //↓↓↓↓↓↓以下部分根据具体业务修改↓↓↓↓↓↓
      //格式转换
      let wordData = this.transforData(data);
      //↑↑↑↑↑↑以上部分根据具体业务修改↑↑↑↑↑↑
      this.showView = true;
      this.$nextTick(() => {
        this.$refs.wordInfo.init(wordData, "/wordes/certificateOfService.docx");
      })
    },
    downloadWord(data) {
      if(data.registerState == null || data.registerState == ""){
        //预览前先进行保存
        data.registerState = '0';
        data.registerId = this.id;
        data.processId = this.processId;
        saveObj(data).then((res) => {
        })
      }
      let wordData = this.transforData(data);
      WordView.methods.exportDoc(wordData, "/wordes/certificateOfService.docx", "送达回证.docx");
    },
    transforData(obj) {
      let s = JSON.stringify(obj);
      let data = JSON.parse(s);
      if (data.deliveryWay == "直接送达"){
        data.zhi = true;
        data.jie = false;
      }else {
        data.zhi = false;
        data.jie = true;
      }
      if (data.deliveryWay == "留置送达"){
        data.liu = true;
        data.zhii = false;
      }else {
        data.liu = false;
        data.zhii = true;
      }
      if (data.deliveryWay == "委托送达"){
        data.wei = true;
        data.tuo = false;
      }else {
        data.wei = false;
        data.tuo = true;
      }
      if (data.deliveryWay == "邮递送达"){
        data.you = true;
        data.di = false;
      }else {
        data.you = false;
        data.di = true;
      }
      if (data.deliveryWay == "公告送达"){
        data.gong = true;
        data.gao = false;
      }else {
        data.gong = false;
        data.gao = true;
      }
      if (data.deliveryWay == "电子送达"){
        data.dian = true;
        data.zi = false;
      }else {
        data.dian = false;
        data.zi = true;
      }
      if (data.isReject == "1"){
        data.shi = true;
        data.si = false;
      }else {
        data.shi = false;
        data.si = true;
      }
      if (data.isReject == "0"){
        data.fou = true;
        data.fo = false;
      }else {
        data.fou = false;
        data.fo = true;
      }
      if (data.deliveryDate != '' && data.deliveryDate != null) {
        data.deliveryDate = moment(data.deliveryDate).format('YYYY年MM月DD日');
      }else {
        data.deliveryDate = '  年  月  日'
      }

      if (data.receiptTime != '' && data.receiptTime != null) {
        data.receiptTime = moment(data.receiptTime).format('YYYY年MM月DD日');
      }else {
        data.receiptTime = '  年  月  日'
      }

      if (data.deliveryTime != '' && data.deliveryTime != null) {
        data.deliveryTime = moment(data.deliveryTime).format('YYYY年MM月DD日');
      }else {
        data.deliveryTime = '  年  月  日'
      }

      return data;
    }
  }
}
</script>

<style scoped>

</style>
